package com.redhat.thermostat.tools.eclipse.plugin.model;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;

@XmlAccessorType(XmlAccessType.NONE)
@XmlType(propOrder = {
        "longName",
        "shortName",
        "argument",
        "required",
        "description"})
public class Option extends ModelObject {

    private String longName;
    private String shortName;
    private String argument;
    private boolean required;
    private String description;

    public Option() {
        // empty no-arg constructor
    }

    public Option(Option other) {
        this.longName = other.longName;
        this.shortName = other.shortName;
        this.argument = other.argument;
        this.required = other.required;
        this.description = other.description;
    }

    @XmlElement(name="long")
    public String getLongName() {
        return longName;
    }

    public void setLongName(String longName) {
        firePropertyChange("longName", this.longName, this.longName = longName);
    }

    @XmlElement(name="short")
    public String getShortName() {
        return shortName;
    }

    public void setShortName(String shortName) {
        firePropertyChange("shortName", this.shortName, this.shortName = shortName);
    }

    @XmlElement(name="argument")
    public String getArgument() {
        return argument;
    }

    public void setArgument(String argument) {
        firePropertyChange("argument", this.argument, this.argument = argument);
    }

    @XmlElement(name="required")
    public boolean getRequired() {
        return required;
    }

    public void setRequired(boolean required) {
        firePropertyChange("required", this.required, this.required = required);
    }

    @XmlElement(name="description")
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        firePropertyChange("description", this.description, this.description = description);
    }
}
